#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <complex>
#include <cmath>
#include <algorithm>
#include <stdlib.h>
#include "wavelet2d.h"
#include <opencv/cv.h>
#include <opencv/highgui.h>
#include <opencv/cxcore.h>
#include <opencv2/core/core.hpp>
#include <opencv2/highgui/highgui.hpp>

using namespace std;
using namespace cv;
void *maxval(vector<vector<double>> &arr, double &max)
{ //找到最大值，二维的
	max = 0;
	for (unsigned int i = 0; i < arr.size(); i++)
	{
		for (unsigned int j = 0; j < arr[0].size(); j++)
		{
			if (max <= arr[i][j])
			{
				max = arr[i][j];
			}
		}
	}
	return 0;
}
void img_compute(const char *tx_Id, const char *input_image, const char *output_image, int rows_start, int rows_end, int cols_start, int cols_end)
{
	
	Mat img0 = imread(input_image);
	
	//cout<<img0.rows<<" "<<img0.cols<<endl;
	Mat img = img0(Range(rows_start, rows_end), Range(cols_start, cols_end));
	int rows = img.rows;
	int cols = img.cols;
	//imshow("lena",img0);
	//imshow("lena",img);
	//waitKey(); //等待用户操作

	Mat channel_origin[3];
	Mat channel[3];
	split(img, channel);
	split(img0, channel_origin);
	//	int opw = getOptimalDFTSize(cols);
	//	int oph = getOptimalDFTSize(rows);

	//	copyMakeBorder(img, padded, 0, oph-rows, 0, opw-cols, BORDER_CONSTANT, Scalar::all(0));

	//	Mat planes[] = {Mat_<float>(padded), Mat::zeros(padded.size()),CV_32F};;
	//	Mar complexI;
	//	merge(planes, 2, complexI);
	
	vector<vector<double>> vec1(rows, vector<double>(cols));
	vector<vector<double>> vec2(rows, vector<double>(cols));
	vector<vector<double>> vec3(rows, vector<double>(cols));

	uchar **array_1 = new uchar *[channel[0].rows];
	uchar **array_2 = new uchar *[channel[1].rows];
	uchar **array_3 = new uchar *[channel[2].rows];

	for (int i = 0; i < channel[0].rows; i++)
	{
		array_1[i] = new uchar[channel[0].cols];
	}

	for (int i = 0; i < channel[0].rows; i++)
	{
		array_1[i] = channel[0].ptr<uchar>(i);
	}

	for (int i = 0; i < rows; i++)
	{
		for (int j = 0; j < cols; j++)
		{
			unsigned char temp;
			temp = array_1[i][j];
			vec1[i][j] = (double)temp;
		}
	}

	for (int i = 0; i < channel[1].rows; i++)
	{
		array_2[i] = new uchar[channel[1].cols];
	}

	for (int i = 0; i < channel[1].rows; i++)
	{
		array_2[i] = channel[1].ptr<uchar>(i);
	}

	for (int i = 0; i < rows; i++)
	{
		for (int j = 0; j < cols; j++)
		{
			unsigned char temp;
			temp = array_2[i][j];
			vec2[i][j] = (double)temp;
		}
	}

	for (int i = 0; i < channel[2].rows; i++)
	{
		array_3[i] = new uchar[channel[2].cols];
	}

	for (int i = 0; i < channel[2].rows; i++)
	{
		array_3[i] = channel[2].ptr<uchar>(i);
	}

	for (int i = 0; i < rows; i++)
	{
		for (int j = 0; j < cols; j++)
		{
			unsigned char temp;
			temp = array_3[i][j];
			vec3[i][j] = (double)temp;
		}
	}
	string nm = "bior4.4"; //bior1.3小波，就是用来生成离散小波的
	vector<double> l1, h1, l2, h2;
	filtcoef(nm, l1, h1, l2, h2); //unkown usage,过滤
	// unsigned int lf=l1.size();
	//  int rows_n =(int) (rows+ J*(lf-1));
	//  int cols_n =(int)  (cols + J * ( lf -1));

	// Finding 2D DWT Transform of the image using symetric extension algorithm
	// Extension is set to 3 (eg., int e = 3)

	vector<int> length;
	vector<double> output1, output2, output3, flag1, flag2, flag3;
	int J = 4; //小波变换的数量，分离次数

	char *tmp_data = (char *)malloc(sizeof(char) * 100);
	strncpy(tmp_data, tx_Id, 100);
	dwt_2d_sym(vec1, J, nm, output1, flag1, length, tmp_data); //这个就是BCH的植入
	//dwt_2d_sym(vec2,J,nm,output2,flag2,length,tmp_data);
	//dwt_2d_sym(vec3,J,nm,output3,flag3,length,tmp_data);

	double max;
	vector<int> length2;
	// This algorithm computes DWT of image of any given size. Together with convolution and
	// subsampling operations it is clear that subsampled images are of different length than
	// dyadic length images. In order to compute the "effective" size of DWT we do additional
	// calculations.
	dwt_output_dim_sym(length, length2, J); //设置输出的大小，J是层数，小波变换的数量
	// length2 is gives the integer vector that contains the size of subimages that will
	// combine to form the displayed output image. The last two entries of length2 gives the
	// size of DWT ( rows_n by cols_n)
	//for(auto i:length2)
	//cout<<i<<" ";
	int siz = length2.size();
	int rows_n = length2[siz - 2];
	int cols_n = length2[siz - 1];

	vector<vector<double>> dwtdisp1(rows_n, vector<double>(cols_n));
	//vector<vector< double> > dwtdisp2(rows_n, vector<double>(cols_n));
	//vector<vector< double> > dwtdisp3(rows_n, vector<double>(cols_n));//显示的输出数组

	dispDWT(output1, dwtdisp1, length, length2, J);
	//dispDWT(output2,dwtdisp2, length ,length2, J);
	//dispDWT(output3,dwtdisp3, length ,length2, J);//直接小波变换后的输出

	//dispDWT_Test(output, dwtdisp, length, length2, J);

	vector<vector<double>> dwt_output1 = dwtdisp1;
	//vector<vector<double> >  dwt_output2= dwtdisp2;
	//vector<vector<double> >  dwt_output3= dwtdisp3;

	maxval(dwt_output1, max);
	//maxval(dwt_output2,max);// max value is needed to take care of overflow
	//maxval(dwt_output3,max);//防止溢出
	//which happens because
	// max value is needed to take care of overflow which happens because
	// of convolution operations performed on unsigned 8 bit images

	//Displaying Scaled Image
	// Creating Image in OPENCV
	/*	IplImage *cvImg; // image used for output
	CvSize imgSize; // size of output image

	imgSize.width = cols_n;
	imgSize.height = rows_n;

	cvImg = cvCreateImage( imgSize, 8, 1 );
	// dwt_hold is created to hold the dwt output as further operations need to be
	// carried out on dwt_output in order to display scaled images.
	vector<vector<double> > dwt_hold(rows_n, vector<double>( cols_n));
	dwt_hold = dwt_output1;
	// Setting coefficients of created image to the scaled DWT output values
	for (int i = 0; i < imgSize.height; i++ ) {
		for (int j = 0; j < imgSize.width; j++ ){
			if ( dwt_output1[i][j] <= 0.0){
				dwt_output1[i][j] = 0.0;
			}
			if ( i <= (length2[0]) && j <= (length2[1]) ) {
				((uchar*)(cvImg->imageData + cvImg->widthStep*i))[j] =
						(char) ( (dwt_output1[i][j] / max) * 255.0);
			} else {
				((uchar*)(cvImg->imageData + cvImg->widthStep*i))[j] =
						(char) (dwt_output1[i][j]) ;
			}
		}
	}//这个是为了输出。

	cvNamedWindow( "DWT Image", 1 ); // creation of a visualisation window
	cvShowImage( "DWT Image", cvImg ); // image visualisation
	cvWaitKey();
	cvDestroyWindow("DWT Image");
	cvSaveImage("dwt.bmp",cvImg);

		dwt_hold = dwt_output2;
	// Setting coefficients of created image to the scaled DWT output values
	for (int i = 0; i < imgSize.height; i++ ) {
		for (int j = 0; j < imgSize.width; j++ ){
			if ( dwt_output2[i][j] <= 0.0){
				dwt_output2[i][j] = 0.0;
			}
			if ( i <= (length2[0]) && j <= (length2[1]) ) {
				((uchar*)(cvImg->imageData + cvImg->widthStep*i))[j] =
						(char) ( (dwt_output2[i][j] / max) * 255.0);
			} else {
				((uchar*)(cvImg->imageData + cvImg->widthStep*i))[j] =
						(char) (dwt_output2[i][j]) ;
			}
		}
	}

	cvNamedWindow( "DWT Image", 1 ); // creation of a visualisation window
	cvShowImage( "DWT Image", cvImg ); // image visualisation
	cvWaitKey();
	cvDestroyWindow("DWT Image");
	cvSaveImage("dwt.bmp",cvImg);
		dwt_hold = dwt_output3;
	// Setting coefficients of created image to the scaled DWT output values
	for (int i = 0; i < imgSize.height; i++ ) {
		for (int j = 0; j < imgSize.width; j++ ){
			if ( dwt_output3[i][j] <= 0.0){
				dwt_output3[i][j] = 0.0;
			}
			if ( i <= (length2[0]) && j <= (length2[1]) ) {
				((uchar*)(cvImg->imageData + cvImg->widthStep*i))[j] =
						(char) ( (dwt_output3[i][j] / max) * 255.0);
			} else {
				((uchar*)(cvImg->imageData + cvImg->widthStep*i))[j] =
						(char) (dwt_output3[i][j]) ;
			}
		}
	}

	cvNamedWindow( "DWT Image", 1 ); // creation of a visualisation window
	cvShowImage( "DWT Image", cvImg ); // image visualisation
	cvWaitKey();
	cvDestroyWindow("DWT Image");
	cvSaveImage("dwt.bmp",cvImg);
	*/
	vector<vector<double>> idwt_output1(rows, vector<double>(cols));
	//vector<vector<double> > idwt_output2(rows, vector<double>(cols));
	//vector<vector<double> > idwt_output3(rows, vector<double>(cols));

	idwt_2d_sym(output1, flag1, nm, idwt_output1, length);
	//idwt_2d_sym(output2,flag2, nm, idwt_output2,length);
	//idwt_2d_sym(output3,flag3, nm, idwt_output3,length);
	//cout<<"dick fuck\n";
	for (int i = 0; i < rows; i++)
	{
		for (int j = 0; j < cols; j++)
			if (idwt_output1[i][j] >= 255)
			{
				idwt_output1[i][j] = 255;
				//cout<<idwt_output1[i][j]<<" ";
			}
	}
	for (int i = 0; i < 512; i++)
	{
		//	for(int j = 0; j<512;j++)
		//if(idwt_output2[i][j]>=255)
		//cout<<idwt_output2[i][j]<<" ";
	}
	for (int i = 0; i < 512; i++)
	{
		//for(int j = 0; j<512;j++)
		//	if(idwt_output3[i][j]>=255)
		//cout<<idwt_output3[i][j]<<" ";
	}
	//Displaying Reconstructed Image
	Mat idwtImage(rows, cols, 8, 3);
	//cout<<"fuck dick"<<endl;
	//cout<<idwtImage.cols<<endl;
	//cout<<idwtImage.rows<<endl;
	for (int i = rows_start; i < rows_end; ++i)
		for (int j = cols_start; j < cols_end; ++j)
		{
			channel_origin[0].at<uchar>(i, j) = idwt_output1.at(i - rows_start).at(j - cols_start);
			channel_origin[1].at<uchar>(i, j) = vec2.at(i - rows_start).at(j - cols_start);
			channel_origin[2].at<uchar>(i, j) = vec3.at(i - rows_start).at(j - cols_start);
			//cout<<i-rows_start<<"  "<<j-cols_start<<endl;
			//channel[1].at<uchar>(i, j) = idwt_output2.at(i).at(j);
			//channel[2].at<uchar>(i, j) = idwt_output3.at(i).at(j);
		}

	merge(channel_origin, 3, idwtImage);
	imwrite(output_image, idwtImage);
}

int main(int argc, char **argv)
{
	string tmp_1 = argv[1]; //watermarkting message
	string tmp_2 = argv[2]; //input image
	string tmp_3 = argv[3]; //output image

	img_compute(tmp_1.c_str(), tmp_2.c_str(), "./tmp_1.jpg", 0, 900, 0, 900);
	img_compute(tmp_1.c_str(), "./tmp_1.jpg", "tmp_2.jpg", 900, 1800, 900, 1800);
	img_compute(tmp_1.c_str(), "./tmp_2.jpg", "tmp_3.jpg", 0, 900, 900, 1800);
	img_compute(tmp_1.c_str(), "./tmp_3.jpg", tmp_3.c_str(), 900, 1800, 0, 900);
}