#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <complex>
#include <cmath>
#include <algorithm>
#include <stdlib.h>
#include "wavelet2d.h"
#include <opencv/cv.h>
#include <opencv/highgui.h>
#include <opencv/cxcore.h>
#include <opencv2/core/core.hpp>
#include <opencv2/highgui/highgui.hpp>

using namespace std;
using namespace cv;
void *maxval(vector<vector<double>> &arr, double &max)
{ //找到最大值，二维的
	max = 0;
	for (unsigned int i = 0; i < arr.size(); i++)
	{
		for (unsigned int j = 0; j < arr[0].size(); j++)
		{
			if (max <= arr[i][j])
			{
				max = arr[i][j];
			}
		}
	}
	return 0;
}

char *img_compute(Mat img1, int rows_start, int rows_end, int cols_start, int cols_end)
{
	Mat img2 = img1(Range(rows_start, rows_end), Range(cols_start, cols_end));
	int rows2 = img2.rows;
	int cols2 = img2.cols;
	//imshow("lena",img2);
	//imshow("recon",img1);
	//waitKey(); //等待用户操作
	Mat channel2[3];
	split(img2, channel2);

	//cout<<"rows "<<rows2<<"cols "<<cols2<<endl;

	vector<vector<double>> vec12(rows2, vector<double>(cols2));
	vector<vector<double>> vec22(rows2, vector<double>(cols2));
	vector<vector<double>> vec32(rows2, vector<double>(cols2));

	/*for(int i=0;i<rows;i++){
        for(int j=0;i<cols;j++){
            vec1[i][j] = (double)(rand()%200);
        }
    }

     for(int i=0;i<rows;i++){
        for(int j=0;i<cols;j++){
            vec2[i][j] = (double)(rand()%200);
        }
    }
    
     for(int i=0;i<rows;i++){
        for(int j=0;i<cols;j++){
            vec3[i][j] = (double)(rand()%200);
        }
    }*/

	uchar **array_12 = new uchar *[channel2[0].rows];
	uchar **array_22 = new uchar *[channel2[1].rows];
	uchar **array_32 = new uchar *[channel2[2].rows];

	for (int i = 0; i < channel2[0].rows; i++)
	{
		array_12[i] = new uchar[channel2[0].cols];
	}

	for (int i = 0; i < channel2[0].rows; i++)
	{
		array_12[i] = channel2[0].ptr<uchar>(i);
	}

	for (int i = 0; i < rows2; i++)
	{
		for (int j = 0; j < cols2; j++)
		{
			unsigned char temp;
			temp = array_12[i][j];
			vec12[i][j] = (double)temp;
		}
	}

	for (int i = 0; i < channel2[1].rows; i++)
	{
		array_22[i] = new uchar[channel2[1].cols];
	}

	for (int i = 0; i < channel2[1].rows; i++)
	{
		array_22[i] = channel2[1].ptr<uchar>(i);
	}

	for (int i = 0; i < rows2; i++)
	{
		for (int j = 0; j < cols2; j++)
		{
			unsigned char temp;
			temp = array_22[i][j];
			vec22[i][j] = (double)temp;
		}
	}

	for (int i = 0; i < channel2[2].rows; i++)
	{
		array_32[i] = new uchar[channel2[2].cols];
	}

	for (int i = 0; i < channel2[2].rows; i++)
	{
		array_32[i] = channel2[2].ptr<uchar>(i);
	}

	for (int i = 0; i < rows2; i++)
	{
		for (int j = 0; j < cols2; j++)
		{
			unsigned char temp;
			temp = array_32[i][j];
			vec32[i][j] = (double)temp;
		}
	}
	string nm2 = "bior4.4"; //bior1.3小波，就是用来生成离散小波的
	vector<double> l12, h12, l22, h22;
	filtcoef(nm2, l12, h12, l22, h22); //unkown usage,过滤

	vector<int> length3;
	vector<double> output12, output22, output32, flag12, flag22, flag32;
	int J2 = 4; //小波变换的数量，分离次数
	return dwt_2d_sym_pei(vec12, J2, nm2, output12, flag12, length3);
}

int main(int argc, char **argv)
{ //argv[1] is datapath of input image.
	Mat img1 = imread(argv[1]);
	char *tmp_tx_1 = img_compute(img1, 0, 900, 0, 900);
	char *tmp_tx_2 = img_compute(img1, 0, 900, 900, 1800);
	char *tmp_tx_3 = img_compute(img1, 900, 1800, 0, 900);
	char *tmp_tx_4 = img_compute(img1, 900, 1800, 900, 1800);

	char ans[65];

	for (int i = 0; i < 64; ++i)
	{
		if (tmp_tx_1[i] == tmp_tx_2[i] || tmp_tx_1[i] == tmp_tx_3[i] || tmp_tx_1[i] == tmp_tx_4[i])
			ans[i] = tmp_tx_1[i];
		else if (tmp_tx_2[i] == tmp_tx_3[i] || tmp_tx_2[i] == tmp_tx_4[i])
			ans[i] = tmp_tx_2[i];
		else if (tmp_tx_3[i] == tmp_tx_4[i])
			ans[i] = tmp_tx_3[i];
		else 
			ans[i] = tmp_tx_1[i];
	}
	ans[64] = '\0';
	cout << ans<<endl;

	return 0;
}